package servertest;

import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.Path;
import java.util.concurrent.TimeUnit;

import org.apache.commons.io.IOUtils;

public class Compiler {
	
	private static final String MAVEN_PATH = "c:/services/maven/bin/mvn.cmd";

	public static void compile(Path pathToPom) throws IOException, InterruptedException {
		String compilationCommand = String.format("%s package -f %s -DskipTests", MAVEN_PATH, pathToPom);
		
		System.out.printf("Compiling server '%s'\n", pathToPom);
		System.out.printf("Command> %s\n", compilationCommand);
		Process compilationProcess = Runtime.getRuntime().exec(compilationCommand);
		compilationProcess.getOutputStream().close();
		
		compilationProcess.waitFor(2, TimeUnit.MINUTES);
		
		IOUtils.copy(compilationProcess.getInputStream(), new FileOutputStream("mvn-package-stdout.txt"));
		IOUtils.copy(compilationProcess.getErrorStream(), new FileOutputStream("mvn-package-stderr.txt"));
		
		System.out.println("Compilation done!");
	}
	
}
