package servertest;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.stream.Stream;

import javaslang.control.Try;

import org.apache.commons.io.IOUtils;

public class ManualMain {
	
	public static void main(String[] args) throws FileNotFoundException, IOException {
		Path semestralsDir = Paths.get("c:/OI/vyuka-ass/cviceni/semestral/eval-3/");
		
		int port = 8080;
		while(!PortCheckUtil.available(port)) {
			port++;
		}
		
		for(String path : semestralsDir.toFile().list()) {
			Path semestralDir = semestralsDir.resolve(path);
			Main.main(new String[] {semestralDir.toAbsolutePath().toString(), port+""});
			
			// copy report
			Stream.of(
					"report.html",
					"stdout.txt",
					"stderr.txt",
					"mvn-package-stdout.txt",
					"mvn-package-stderr.txt"
			).forEach(file -> Try.run(() -> IOUtils.copy(new FileInputStream(file), new FileOutputStream(semestralDir.resolve(file).toFile()))));
			
			System.out.printf("Server '%s' done!\n", path);
			while(!PortCheckUtil.available(++port)) {
				port++;
			}
		}
	}
	
}
